/*  ४祭 ஢   - . 18  2002 */

/*  ⠡  ஢ ᪨ ᫮ 
  ୠ⨢ ஢
  -- ., 14  1995
  --  ⠪  8
  -- 9  1998
  --  ⠪  WIN
  -- 30  2001
  . #ifdef CYRILLIC

 ९ᠭ ࠧ ;   ᪠  ⥪饩
 ४ਨ ( ᮣᮢ  emTeX), ᫨ #defined
 LOOK_CURRENT_DIR; 襭 ᪨
 樮 ⥬ - shen@mccme.ru (19.09.2000)
*/

/*
 *
 *  This file is part of
 *  MakeIndex - A formatter and format independent index processor
 *
 *  Copyright (C) 1989 by Chen & Harrison International Systems, Inc.
 *  Copyright (C) 1988 by Olivetti Research Center
 *  Copyright (C) 1987 by Regents of the University of California
 *
 *  Author:
 *  Pehong Chen
 *      Chen & Harrison International Systems, Inc.
 *  Palo Alto, California
 *  USA
 *  (phc@renoir.berkeley.edu or chen@orc.olivetti.com)
 *
 *  Contributors:
 *  Please refer to the CONTRIB file that comes with this release
 *  for a list of people who have contributed to this and/or previous
 *  release(s) of MakeIndex.
 *
 *  All rights reserved by the copyright holders.  See the copyright
 *  notice distributed with this software for a complete description of
 *  the conditions under which it is made available.
 *
 */


#include <assert.h>

#define MKIND_C 1
#include    "mkind.h"
#undef MKIND_C

extern int* LETTER_NUMBER;
extern int  LETTER_NUMBER_koi[];
extern int  LETTER_NUMBER_win[];
extern int  LETTER_NUMBER_alt[];

#ifdef CYRILLIC

/* ⠡  ୠ⨢ ஢ */

int RUSISLOWER_alt[256]=
{
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
    0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*128, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*144, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*160, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*176, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*192, ,  ,  ,  ,  ,  ,  ,   ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
/*240,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

int RUSISUPPER_alt[256]=
{
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*   ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
    0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*  @,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,
/*  P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  `,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  p,  q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  ,  ,  ,  ,  ,  ,  ,  ,   ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
/*  ,  ,  ,  ,  ,  ,    ,  ,  ,  ,  ,  ,  ,  ,    */
};

unsigned char RUSTOUPPER_alt[256]=
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
   64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
   96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,123,124,125,126,127,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
/*128, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
/*144, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
/*160, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
/*176, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
/*192, ,  ,  ,  ,  ,  ,  ,   ,  ,  ,  ,  ,  ,  ,  , */
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  240,240,242,243,244,245,246,247,248,249,250,251,252,253,254,255
/*240,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

unsigned char RUSTOLOWER_alt[256]=
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
   64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
  112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
   96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
  112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

  160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
/*128, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
/*144, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
/*160, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
/*176, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
/*192, ,  ,  ,  ,  ,  ,  ,   ,  ,  ,  ,  ,  ,  ,  , */
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  241,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
/*240,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

/* ⠡  ஢ 8r */

int RUSISLOWER_koi[256]=
{
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
    0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*128                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*144                                                              */
    0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*160                                                             */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*176                                                             */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

int RUSISUPPER_koi[256]=
{
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
    0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*128                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*144                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*160                                                             */
    0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*176                                                             */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

unsigned char RUSTOUPPER_koi[256]=
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
   64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
   96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,123,124,125,126,127,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
/*128                                                              */
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
/*144                                                              */
  160,161,162,179,164,165,166,167,168,169,170,171,172,173,174,175,
/*160                                                             */
  176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
/*176                                                             */
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

unsigned char RUSTOLOWER_koi[256]=
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
   64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
  112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
   96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
  112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
/*128                                                              */
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
/*144                                                              */
  160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
/*160                                                             */
  176,177,178,163,180,181,182,183,184,185,186,187,188,189,190,191,
/*176                                                             */
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

/* ⠡  ஢ CP_1251 */

int RUSISLOWER_win[256]=
{
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
    0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*128                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*144                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*160                                                             */
    0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,
/*176                                                             */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

int RUSISUPPER_win[256]=
{
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
    0,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  0,  0,  0,  0,  0,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*128                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*144                                                              */
    0,  0,  0,  0,  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,
/*160                                                             */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*176                                                             */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
    0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

unsigned char RUSTOUPPER_win[256]=
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
   64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
   96, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
   80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90,123,124,125,126,127,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
/*128                                                              */
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
/*144                                                              */
  160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
/*160                                                             */
  176,177,178,179,180,181,182,183,168,185,186,187,188,189,190,191,
/*176                                                             */
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

unsigned char RUSTOLOWER_win[256]=
{
    0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
/*  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, */
   16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
/* 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, */
   32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
/*32 ,  !,  ",  #,  $,  %,  &,  ',  (,  ),  *,  +,  ,,  -,  .,  /, */
   48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
/*480,  1,  2,  3,  4,  5,  6,  7,  8,  9,  :,  ;,  <,  =,  >,  ?, */
   64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
/*64@,  A,  B,  C,  D,  E,  F,  G,  H,  I,  J,  K,  L,  M,  N,  O, */
  112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95,
/*80P,  Q,  R,  S,  T,  U,  V,  W,  X,  Y,  Z,  [,  \,  ],  ^,  _, */
   96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
/*96`,  a,  b,  c,  d,  e,  f,  g,  h,  i,  j,  k,  l,  m,  n,  o, */
  112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
/*112p, q,  r,  s,  t,  u,  v,  w,  x,  y,  z,  {,  |,  },  ~,  , */

  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
/*128                                                              */
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
/*144                                                              */
  160,161,162,163,164,165,166,167,184,169,170,171,172,173,174,175,
/*160                                                             */
  176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
/*176                                                             */
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
/*192, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255,
/*208, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
/*224, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  , */
  240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
/*240, ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,  ,    */
};

#ifdef CYRILLIC_ALT
  int* RUSISUPPER             = RUSISUPPER_alt;
  int* RUSISLOWER             = RUSISLOWER_alt;
  unsigned char* RUSTOUPPER   = RUSTOUPPER_alt;
  unsigned char* RUSTOLOWER   = RUSTOLOWER_alt;
#endif

#ifdef CYRILLIC_WIN
  int* RUSISUPPER             = RUSISUPPER_win;
  int* RUSISLOWER             = RUSISLOWER_win;
  unsigned char* RUSTOUPPER   = RUSTOUPPER_win;
  unsigned char* RUSTOLOWER   = RUSTOLOWER_win;
#endif

#ifdef CYRILLIC_KOI
  int* RUSISUPPER             = RUSISUPPER_koi;
  int* RUSISLOWER             = RUSISLOWER_koi;
  unsigned char* RUSTOUPPER   = RUSTOUPPER_koi;
  unsigned char* RUSTOLOWER   = RUSTOLOWER_koi;
#endif

#endif

int     letter_ordering = FALSE;
int     compress_blanks = FALSE;
int     merge_page = TRUE;
int     init_page = FALSE;
int     even_odd = -1;
int     verbose = TRUE;
int     german_sort = FALSE;
int     fn_no = -1;                    /* total number of files */
int     idx_dot = TRUE;                /* flag which shows dot in ilg being
                                        * active */
int     idx_tt = 0;                    /* total entry count (all files) */
int     idx_et = 0;                    /* erroneous entry count (all files) */
int     idx_gt = 0;                    /* good entry count (all files) */

FIELD_PTR *idx_key;
FILE   *log_fp;
FILE   *sty_fp;
FILE   *idx_fp;
FILE   *ind_fp;
FILE   *ilg_fp;

char   *pgm_fn;
char    sty_fn[ARRAY_MAX]; /* 뫮 LINE_MAX: , 訡 */
char   *idx_fn;
char    ind[STRING_MAX];
char   *ind_fn;
char    ilg[STRING_MAX];
char   *ilg_fn;
char    pageno[NUMBER_MAX];

static char log_fn[STRING_MAX];
static char base[STRING_MAX];
static int need_version = TRUE;

static  void    check_all (char *fn,int ind_given,int ilg_given,
                        int log_given);
static  void    check_idx (char *fn,int open_fn);
static  void    find_pageno (void);
static  void    open_sty (char *fn);
static  void    prepare_idx (void);
static  void    process_idx (char * *fn,int use_stdin,int sty_given,
                        int ind_given,int ilg_given,int log_given);

#ifdef DOS_TURBO
unsigned        _stklen = 0xf000;       /* Turbo C ignores size set in
                                        .exe file by LINK or EXEMOD,
                                        sigh... */
#endif                                  /* DOS_TURBO */

#ifdef DEBUG
long totmem = 0L;                       /* for debugging memory usage */
#endif /* DEBUG */

int main(int argc,  char *argv[])
{
    char   *fns[ARRAY_MAX];
    char   *ap;
    int     use_stdin = FALSE;
    int     sty_given = FALSE;
    int     ind_given = FALSE;
    int     ilg_given = FALSE;
    int     log_given = FALSE;

    /* determine program name */
    pgm_fn = strrchr(*argv, DIR_DELIM);
    if (pgm_fn == NULL)
        pgm_fn = *argv;
    else
        pgm_fn++;

#ifdef DOS_TURBO
    {
        register char *ext = pgm_fn + strlen(pgm_fn)-4;
        if ( *ext == '.' )
            *ext = NUL;                 /* cut off ".EXE" */
    }
    (void)strlwr(pgm_fn);               /* lower program name    */
#endif                                  /* DOS_TURBO */

    /* process command line options */
    while (--argc > 0) {
        if (**++argv == SW_PREFIX) {
            if (*(*argv + 1) == NUL)
                break;

#ifdef CYRILLIC
            if (strcmp (*argv, "-koi") == 0)
            {
               LETTER_NUMBER = LETTER_NUMBER_koi;
               RUSISUPPER    = RUSISUPPER_koi;
               RUSISLOWER    = RUSISLOWER_koi;
               RUSTOUPPER    = RUSTOUPPER_koi;
               RUSTOLOWER    = RUSTOLOWER_koi;
               continue;
            }

            if (strcmp (*argv, "-win") == 0)
            {
               LETTER_NUMBER = LETTER_NUMBER_win;
               RUSISUPPER    = RUSISUPPER_win;
               RUSISLOWER    = RUSISLOWER_win;
               RUSTOUPPER    = RUSTOUPPER_win;
               RUSTOLOWER    = RUSTOLOWER_win;
               continue;
            }

            if (strcmp (*argv, "-alt") == 0)
            {
               LETTER_NUMBER = LETTER_NUMBER_alt;
               RUSISUPPER    = RUSISUPPER_alt;
               RUSISLOWER    = RUSISLOWER_alt;
               RUSTOUPPER    = RUSTOUPPER_alt;
               RUSTOLOWER    = RUSTOLOWER_alt;
               continue;
            }
#endif

            for (ap = ++*argv; *ap != NUL; ap++)
                switch (*ap) {
                    /* use standard input */
                case 'i':
                    use_stdin = TRUE;
                    break;

                    /* enable letter ordering */
                case 'l':
                    letter_ordering = TRUE;
                    break;

                    /* disable range merge */
                case 'r':
                    merge_page = FALSE;
                    break;

                    /* supress progress message -- quiet mode */
                case 'q':
                    verbose = FALSE;
                    break;

                    /* compress blanks */
                case 'c':
                    compress_blanks = TRUE;
                    break;

                    /* style file */
                case 's':
                    argc--;
                    if (argc <= 0)
                        FATAL0("Expected -s <stylefile>\n");
                    open_sty(*++argv);
                    sty_given = TRUE;
                    break;

                    /* output index file name */
                case 'o':
                    argc--;
                    if (argc <= 0)
                        FATAL0("Expected -o <ind>\n");
                    ind_fn = *++argv;
                    ind_given = TRUE;
                    break;

                    /* transcript file name */
                case 't':
                    argc--;
                    if (argc <= 0)
                        FATAL0("Expected -t <logfile>\n");
                    ilg_fn = *++argv;
                    ilg_given = TRUE;
                    break;

                    /* initial page */
                case 'p':
                    argc--;
                    if (argc <= 0)
                        FATAL0("Expected -p <num>\n");
                    strcpy(pageno, *++argv);
                    init_page = TRUE;
                    if (STREQ(pageno, EVEN)) {
                        log_given = TRUE;
                        even_odd = 2;
                    } else if (STREQ(pageno, ODD)) {
                        log_given = TRUE;
                        even_odd = 1;
                    } else if (STREQ(pageno, ANY)) {
                        log_given = TRUE;
                        even_odd = 0;
                    }
                    break;

                    /* enable german sort */
                case 'g':
                    german_sort = TRUE;
                    break;

#ifdef CYRILLIC
     /*  12  2002  */
     /*  ᪨ 㪢 ।騬 ⨭᪨ */
                case 'z':
                    make_cyrillic_first();
                    break;
#endif

                    /* bad option */
                default:
                    FATAL1("Unknown option -%c.\n", *ap);
                    break;
                }
        } else {
            if (fn_no < ARRAY_MAX) {
                check_idx(*argv, FALSE);
                fns[++fn_no] = *argv;
            } else {
                FATAL1("Too many input files (max %d).\n", ARRAY_MAX);
            }
        }
    }

/* changes for 2.12 (May 20, 1993) by Julian Reschke (jr@ms.maus.de):
   if only one input file and no explicit style file was given */
    if (fn_no == 0 && !sty_given) {
        char tmp[STRING_MAX + 5];
        /* base set by last call to check_idx */
        sprintf (tmp, "%s%s", base, INDEX_STY);
        if (0 == access(tmp, R_OK)) {
            open_sty (tmp);
            sty_given = TRUE;
        }
    }

    process_idx(fns, use_stdin, sty_given, ind_given, ilg_given, log_given);
    idx_gt = idx_tt - idx_et;
    ALL_DONE;
    if (idx_gt > 0) {
        prepare_idx();
        sort_idx();
        gen_ind();
        MESSAGE1("Output written in %s.\n", ind_fn);
    } else
        MESSAGE1("Nothing written in %s.\n", ind_fn);

    MESSAGE1("Transcript written in %s.\n", ilg_fn);
    CLOSE(ind_fp);
    CLOSE(ilg_fp);
    EXIT(0);

#ifdef IBM_PC_TURBO
    return (0);              /* not reached, but keeps compiler happy */
#endif
}


static void prepare_idx(void)
{
    NODE_PTR ptr = head;
    int     i = 0;

#ifdef DEBUG
    totmem += idx_gt * sizeof(FIELD_PTR);
    (void)fprintf(stderr,"prepare_idx(): calloc(%d,%d)\ttotmem = %ld\n",
        idx_gt,sizeof(FIELD_PTR),totmem);
#endif /* DEBUG */

    if (head == (NODE_PTR)NULL)
        FATAL0("No valid index entries collected.\n");

    if ((idx_key = (FIELD_PTR *) calloc(idx_gt, sizeof(FIELD_PTR))) == NULL) {
        FATAL0("Not enough core...abort.\n");
    }
    for (i = 0; i < idx_gt; i++) {
        idx_key[i] = &(ptr->data);
        ptr = ptr->next;
    }
}


static void
process_idx(char *fn[], int use_stdin, int sty_given,
             int ind_given, int ilg_given, int log_given)
{
    int     i;

    if (fn_no == -1)
        /* use stdin if no input files specified */
        use_stdin = TRUE;
    else {
        check_all(fn[0], ind_given, ilg_given, log_given);
        PUT_VERSION;
        if (sty_given)
            scan_sty();
        if (german_sort && (idx_quote == '"'))
FATAL1("Option -g invalid, quote character must be different from '%c'.\n",
'"');
        scan_idx();
        ind_given = TRUE;
        ilg_given = TRUE;
        for (i = 1; i <= fn_no; i++) {
            check_idx(fn[i], TRUE);
            scan_idx();
        }
    }

    if (use_stdin) {
        idx_fn = "stdin";
        idx_fp = stdin;

        if (ind_given) {
            if (!ind_fp && ((ind_fp = OPEN_OUT(ind_fn)) == NULL))
                FATAL1("Can't create output index file %s.\n", ind_fn);
        } else {
            ind_fn = "stdout";
            ind_fp = stdout;
        }

        if (ilg_given) {
            if (!ilg_fp && ((ilg_fp = OPEN_OUT(ilg_fn)) == NULL))
                FATAL1("Can't create transcript file %s.\n", ilg_fn);
        } else {
            ilg_fn = "stderr";
            ilg_fp = stderr;
        }

        if ((fn_no == -1) && (sty_given))
            scan_sty();
        if (german_sort && (idx_quote == '"'))
FATAL1("Option -g ignored, quote character must be different from '%c'.\n",
'"');
        if (need_version) {
            PUT_VERSION;
        }
        scan_idx();
        fn_no++;
    }
}

static void check_idx(char *fn, int open_fn)
{
    char   *ptr = fn;
    char   *ext;
    int     with_ext = FALSE;
    int     i = 0;

    ext = strrchr(fn, EXT_DELIM);
    if ((ext != NULL) && (ext != fn) && (*(ext + 1) != DIR_DELIM)) {
        with_ext = TRUE;
        while ((ptr != ext) && (i < STRING_MAX))
            base[i++] = *ptr++;
    } else{
        while ((*ptr != NUL) && (i < STRING_MAX)){
            base[i++] = *ptr++;
        }
    }

    if (i < STRING_MAX){
        base[i] = NUL;
    }else{
        FATAL2("Index file name %s too long (max %d).\n",
               base, STRING_MAX);
    }
    idx_fn = fn;

    if (   ( open_fn &&
            ((idx_fp = OPEN_IN(idx_fn)) == NULL)
           ) || ((!open_fn) && (access(idx_fn, R_OK) != 0))){
        if (with_ext) {
            FATAL1("Input index file %s not found.\n", idx_fn);
        } else {

#ifdef DEBUG
            totmem += STRING_MAX;
            (void)fprintf(stderr,"check_idx()-2: malloc(%d)\ttotmem = %ld\n",
                    STRING_MAX,totmem);
#endif /* DEBUG */

            if ((idx_fn = (char *) malloc(STRING_MAX)) == NULL)
                FATAL0("Not enough core...abort.\n");
            sprintf(idx_fn, "%s%s", base, INDEX_IDX);
            if ((open_fn && ((idx_fp = OPEN_IN(idx_fn)) == NULL) ) ||
                ((!open_fn) && (access(idx_fn, R_OK) != 0))) {
                FATAL2("Couldn't find input index file %s nor %s.\n", base,
                       idx_fn);
            }
        }
    }
}


static void check_all( char *fn, int ind_given, int ilg_given,
                       int log_given)
{
    check_idx(fn, TRUE);

    /* index output file */
    if (!ind_given) {
        sprintf(ind, "%s%s", base, INDEX_IND);
        ind_fn = ind;
    }
    if ((ind_fp = OPEN_OUT(ind_fn)) == NULL){
        FATAL1("Can't create output index file %s.\n", ind_fn);
    }
    /* index transcript file */
    if (!ilg_given) {
        sprintf(ilg, "%s%s", base, INDEX_ILG);
        ilg_fn = ilg;
    }
    if ((ilg_fp = OPEN_OUT(ilg_fn)) == NULL){
        FATAL1("Can't create transcript file %s.\n", ilg_fn);
    }
    if (log_given) {
        sprintf(log_fn, "%s%s", base, INDEX_LOG);
#ifdef DOS_TURBO                /* open in binary mode (CR-LF) */
        if ((log_fp = OPEN_IN_B(log_fn)) == NULL) {
#else
        if ((log_fp = OPEN_IN(log_fn)) == NULL) {
#endif      /* DOS_TURBO */
            FATAL1("Source log file %s not found.\n", log_fn);
        } else {
            find_pageno();
            CLOSE(log_fp);
        }
    }
}


static void find_pageno(void)
{
    int     i = 0;
    int     p, c;

    fseek(log_fp, -1L, 2);
    p = GET_CHAR(log_fp);
    fseek(log_fp, -2L, 1);
    do {
        c = p;
        p = GET_CHAR(log_fp);
    } while (!(((p == LSQ) && isdigit(c)) || (fseek(log_fp, -2L, 1) != 0)));
    if (p == LSQ) {
        while ((c = GET_CHAR(log_fp)) == SPC);
        do {
            pageno[i++] = (char) c;
            c = GET_CHAR(log_fp);
        } while (isdigit(c));
        pageno[i] = NUL;
    } else {
        fprintf(ilg_fp, "Couldn't find any page number in %s...ignored\n",
                log_fn);
        init_page = FALSE;
    }
}

static void open_sty(char *fn)
{
  /* ⨫ 䠩   fn   ४, 室
      , 㪠  ६ STYLE_PATH; ᫨ 䠩 室,
        頥  sty_fn, 䠩 뢠  㪠⥫ 
      頥  sty_fp; ᫨ , ⠥ ᮮ饭 
     訡  ࠡ 砥 */
  char *path;
  int found;
  int pos;
  int i,j;

  if ((path = getenv(STYLE_PATH)) == NULL) {
      /* style input path not defined, 䠩   ⥪饩 ४ਨ */
    strcpy(sty_fn, fn);
    found= ((sty_fp = OPEN_IN(sty_fn)) != NULL);
  }else{ /* path 㪠뢠  砫 ப,  n ᨬ
       ENV_SEPAR   n+1 ப,   
       㪠뢠  ४,   ᪠ ⨫ 䠩 
        fn; ப 稢 ᨬ NUL */
    found= 0;
#ifdef LOOK_CURRENT_DIR
    /* 砫 饬  ⥪饩 ४ਨ */
    strcpy(sty_fn, fn);
    found= ((sty_fp = OPEN_IN(sty_fn)) != NULL);
#endif /* LOOK_CURRENT_DIR */
    pos= -1;
    /* pos 㪠뢠  ࠧ⥫ । ⠢襩 
        ᬮ  ,    ENV_SEPAR 
        NUL   㣮  pos==-1 (ᮡ 砩); */
    while (!found && !((pos>=0)&&(path[pos]==NUL)) ){
      assert((pos==-1)||(path[pos]==ENV_SEPAR)||(path[pos]==NUL));
      /* ⠥  ஡㥬 । ४: */
      pos++; i= 0;
      while ((path[pos]!=ENV_SEPAR)&&(path[pos]!=NUL)&&(i<ARRAY_MAX)){
        /* 㥬 । ᨬ । ४ਨ   */
        sty_fn[i++]= path[pos++];
      }
      if (i<ARRAY_MAX){sty_fn[i++]= DIR_DELIM; }
      /*  sty_fn ४, ⠫  ᠬ  -    */
      j= 0;
      while ((fn[j]!=NUL)&&(i<ARRAY_MAX)){
        sty_fn[i++]= fn[j++];
      }
      /*  sty_fn[0..i-1]     樨  */
      assert (i<=ARRAY_MAX);
      if (i == ARRAY_MAX){
        /* 墠⨫        NUL */
        sty_fn[ARRAY_MAX-1]=NUL;
        FATAL1("Path %s... too long.\n", sty_fn);
      }else{
        sty_fn[i]= NUL;
        found= ((sty_fp = OPEN_IN(sty_fn)) !=NULL);
      }
    }
    /*  ,  ᪠   */
  }
  if (!found){FATAL1("Index style file %s not found.\n", fn);}
}

int strtoint(char *str)
{
    int     val = 0;

    while (*str != NUL) {
        val = 10 * val + *str - 48;
        str++;
    }
    return (val);
}
